diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatBasic.java b/src/main/java/net/minecraft/core/achievement/stat/StatBasic.java
index 7fa14fdad..bdf809cfa 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/StatBasic.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatBasic.java
@@ -1,23 +1,25 @@
 package net.minecraft.core.achievement.stat;
 
+import net.minecraft.core.util.collection.NamespaceID;
+
 public class StatBasic extends Stat
 {
 
-    public StatBasic(int i, String s, IStatType istattype)
+    public StatBasic(NamespaceID id, String name, StatValueFormatter type)
     {
-        super(i, s, istattype);
+        super(id, name, type);
     }
 
-    public StatBasic(int i, String s)
+    public StatBasic(NamespaceID id, String name)
     {
-        super(i, s);
+        super(id, name);
     }
 
     @Override
 	public Stat registerStat()
     {
         super.registerStat();
-        StatList.statList2.add(this);
+        StatList.basicStats.add(this);
         return this;
     }
 }
diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatDescFormatter.java b/src/main/java/net/minecraft/core/achievement/stat/StatDescFormatter.java
new file mode 100644
index 000000000..d08501030
--- /dev/null
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatDescFormatter.java
@@ -0,0 +1,8 @@
+package net.minecraft.core.achievement.stat;
+
+
+public interface StatDescFormatter
+{
+
+    String formatString(String description);
+}
diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatItem.java b/src/main/java/net/minecraft/core/achievement/stat/StatItem.java
index a4ec4cf97..1613a36c1 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/StatItem.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatItem.java
@@ -2,13 +2,14 @@ package net.minecraft.core.achievement.stat;
 
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.collection.NamespaceID;
 
 public class StatItem extends Stat
 {
 
-    public StatItem(int id, String name, int itemId)
+    public StatItem(NamespaceID id, String key, int itemId)
     {
-        super(id, name);
+        super(id, key);
         itemID = itemId;
     }
 
@@ -16,11 +17,14 @@ public class StatItem extends Stat
     {
         return itemID;
     }
+    public Item getItem(){
+        return Item.getItem(itemID);
+    }
 
     @Override
     public String getStatName()
     {
-        return I18n.getInstance().translateKeyAndFormat(statName, Item.itemsList[itemID].getStatName());
+        return I18n.getInstance().translateKeyAndFormat(statKey, Item.itemsList[itemID].getStatName());
     }
 
     private final int itemID;
diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatList.java b/src/main/java/net/minecraft/core/achievement/stat/StatList.java
index b2f7dbda2..4d9fb95d8 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/StatList.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatList.java
@@ -1,225 +1,312 @@
 package net.minecraft.core.achievement.stat;
 
-import net.minecraft.core.Global;
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.WeightedRandomBag;
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryBlastFurnace;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.item.IItemConvertible;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.crafting.legacy.CraftingManager;
-import net.minecraft.core.crafting.legacy.recipe.IRecipe;
-import net.minecraft.core.crafting.legacy.recipe.RecipesFurnace;
+import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.Nullable;
+import org.jetbrains.annotations.Unmodifiable;
 
 import java.util.*;
 
 public abstract class StatList
 {
 
-    protected static Map<Integer, Stat> statMap = new HashMap<>();
-    public static List<Stat> statList1 = new ArrayList<>();
-    public static List<Stat> statList2 = new ArrayList<>();
-    public static List<Stat> usedItemStatsList = new ArrayList<>();
-    public static List<Stat> statList3 = new ArrayList<>();
-    public static Stat startGameStat = (new StatBasic(1000, "stat.startGame")).setClientside().registerStat();
-    public static Stat createWorldStat = (new StatBasic(1001, "stat.createWorld")).setClientside().registerStat();
-    public static Stat loadWorldStat = (new StatBasic(1002, "stat.loadWorld")).setClientside().registerStat();
-    public static Stat joinMultiplayerStat = (new StatBasic(1003, "stat.joinMultiplayer")).setClientside().registerStat();
-    public static Stat leaveGameStat = (new StatBasic(1004, "stat.leaveGame")).setClientside().registerStat();
-    public static Stat minutesPlayedStat = (new StatBasic(1100, "stat.playOneMinute", Stat.statTypeTime)).setClientside().registerStat();
-    public static Stat distanceWalkedStat = (new StatBasic(2000, "stat.walkOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat distanceSwumStat = (new StatBasic(2001, "stat.swimOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat distanceFallenStat = (new StatBasic(2002, "stat.fallOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat distanceClimbedStat = (new StatBasic(2003, "stat.climbOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat distanceFlownStat = (new StatBasic(2004, "stat.flyOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat distanceDoveStat = (new StatBasic(2005, "stat.diveOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat distanceByMinecartStat = (new StatBasic(2006, "stat.minecartOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat distanceByBoatStat = (new StatBasic(2007, "stat.boatOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat distanceByPigStat = (new StatBasic(2008, "stat.pigOneCm", Stat.statTypeDistance)).setClientside().registerStat();
-    public static Stat jumpStat = (new StatBasic(2010, "stat.jump")).setClientside().registerStat();
-    public static Stat dropStat = (new StatBasic(2011, "stat.drop")).setClientside().registerStat();
-    public static Stat damageDealtStat = (new StatBasic(2020, "stat.damageDealt")).registerStat();
-    public static Stat damageTakenStat = (new StatBasic(2021, "stat.damageTaken")).registerStat();
-    public static Stat deathsStat = (new StatBasic(2022, "stat.deaths")).registerStat();
-    public static Stat mobKillsStat = (new StatBasic(2023, "stat.mobKills")).registerStat();
-    public static Stat playerKillsStat = (new StatBasic(2024, "stat.playerKills")).registerStat();
-    public static Stat fishCaughtStat = (new StatBasic(2025, "stat.fishCaught")).registerStat();
-    public static Stat[] mineBlockStatArray = func_25153_a("stat.mineBlock", 0x1000000);
-    public static Stat[] craftedItemStats;
-    public static Stat[] usedItemStats;
-    public static Stat[] breakItemStats;
-    public static Stat[] pickUpItemStats;
+    protected static Map<NamespaceID, Stat> statMap = new HashMap<>();
+    public static List<Stat> registeredStats = new ArrayList<>();
+    public static List<Stat> basicStats = new ArrayList<>();
+    public static List<Stat> usedItemStats = new ArrayList<>();
+
+    public static final String STAT_USED = "stat_used";
+    public static final String STAT_DEPLETED = "stat_broken";
+    public static final String STAT_CRAFTED = "stat_crafted";
+    public static final String STAT_PICKED_UP = "stat_picked_up";
+    public static final String STAT_MINED = "stat_mined";
+
+    public static Stat startGameStat =
+        new StatBasic(new NamespaceID("minecraft", "start_game"), "stat.startGame").setClientside().registerStat();
+    public static Stat createWorldStat =
+        new StatBasic(new NamespaceID("minecraft", "create_world"), "stat.createWorld").setClientside().registerStat();
+    public static Stat loadWorldStat =
+        new StatBasic(new NamespaceID("minecraft", "load_world"), "stat.loadWorld").setClientside().registerStat();
+    public static Stat joinMultiplayerStat =
+        new StatBasic(new NamespaceID("minecraft", "join_multiplayer"), "stat.joinMultiplayer").setClientside().registerStat();
+    public static Stat leaveGameStat =
+        new StatBasic(new NamespaceID("minecraft", "leave_game"), "stat.leaveGame").setClientside().registerStat();
+    public static Stat minutesPlayedStat =
+        new StatBasic(new NamespaceID("minecraft", "playtime"), "stat.playOneMinute", Stat.statTypeTime).setClientside().registerStat();
+    public static Stat distanceWalkedStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_walk"), "stat.walkOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat distanceSwumStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_swim"), "stat.swimOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat distanceFallenStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_fall"), "stat.fallOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat distanceClimbedStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_climb"), "stat.climbOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat distanceFlownStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_fly"), "stat.flyOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat distanceDoveStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_dive"), "stat.diveOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat distanceByMinecartStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_minecart"), "stat.minecartOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat distanceByBoatStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_boat"), "stat.boatOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat distanceByPigStat =
+        new StatBasic(new NamespaceID("minecraft", "travel_pig"), "stat.pigOneCm", Stat.statTypeDistance).setClientside().registerStat();
+    public static Stat jumpStat =
+        new StatBasic(new NamespaceID("minecraft", "jump"), "stat.jump").setClientside().registerStat();
+    public static Stat dropStat =
+        new StatBasic(new NamespaceID("minecraft", "drop"), "stat.drop").setClientside().registerStat();
+    public static Stat damageDealtStat =
+        new StatBasic(new NamespaceID("minecraft", "damage_dealt"), "stat.damageDealt").registerStat();
+    public static Stat damageTakenStat =
+        new StatBasic(new NamespaceID("minecraft", "damage_taken"), "stat.damageTaken").registerStat();
+    public static Stat deathsStat =
+        new StatBasic(new NamespaceID("minecraft", "deaths"), "stat.deaths").registerStat();
+    public static Stat mobKillsStat =
+        new StatBasic(new NamespaceID("minecraft", "kills_mob"), "stat.mobKills").registerStat();
+    public static Stat playerKillsStat =
+        new StatBasic(new NamespaceID("minecraft", "kills_player"), "stat.playerKills").registerStat();
+    public static Stat fishCaughtStat =
+        new StatBasic(new NamespaceID("minecraft", "caught_fish"), "stat.fishCaught").registerStat();
+
     public static Map<String, Stat> mobEncounterStats;
-    private static boolean blocksInitialized = false;
-    private static boolean itemsInitialized = false;
 
-    static
-    {
-        AchievementList.init();
-    }
+    public static Map<Integer, Integer> replacementMap = new HashMap<>();
 
     public StatList()
     {
     }
 
-    public static void init()
-    {
-    }
+    public static void initReplaceMap() {
+        for (Item item : Item.itemsList){
+            if (item == null) continue;
+            Item parent = item.getStatParent();
+            if (parent == null) continue;
 
-    public static void onBlockInit()
-    {
-        usedItemStats = initUsedItemStats(usedItemStats, "stat.useItem", 0x1020000, 0, Block.blocksList.length);
-        breakItemStats = initBreakItemStats(breakItemStats, "stat.breakItem", 0x1030000, 0, Block.blocksList.length);
-        blocksInitialized = true;
-        blocksAndItemsInitialized();
+            if (item.id == parent.id){
+                throw new RuntimeException("Attempted to set '" + item.namespaceID + "' parent to itself!");
+            }
+            replacementMap.put(item.id, parent.id);
+        }
     }
 
-    public static void onItemInit()
+    public static void init()
     {
-        usedItemStats = initUsedItemStats(usedItemStats, "stat.useItem", 0x1020000, Block.blocksList.length, Item.itemsList.length);
-        breakItemStats = initBreakItemStats(breakItemStats, "stat.breakItem", 0x1030000, Block.blocksList.length, Item.itemsList.length);
-        itemsInitialized = true;
-        blocksAndItemsInitialized();
-    }
+        initReplaceMap();
+        Achievements.init();
 
-    public static void blocksAndItemsInitialized()
-    {
-        if(!blocksInitialized || !itemsInitialized)
-        {
-            return;
-        }
-        HashSet hashset = new HashSet();
-        IRecipe irecipe;
-        for (Iterator iterator = CraftingManager.getInstance().getRecipeList().iterator(); iterator.hasNext(); hashset.add(Integer.valueOf(irecipe.getRecipeOutput().itemID)))
-        {
-            irecipe = (IRecipe)iterator.next();
+        HashSet<Integer> craftable = new HashSet<>();
+        for (RecipeEntryCrafting<?,?> r : Registries.RECIPES.getAllCraftingRecipes()){
+            if (r.getOutput() instanceof ItemStack){
+                craftable.add(((ItemStack) r.getOutput()).itemID);
+            } else if (r.getOutput() instanceof IItemConvertible) {
+                craftable.add((((Item) r.getOutput()).asItem()).id);
+            }
         }
-
-        ItemStack itemstack;
-        for (Iterator iterator1 = RecipesFurnace.getInstance().getSmeltingList().values().iterator(); iterator1.hasNext(); hashset.add(Integer.valueOf(itemstack.itemID)))
-        {
-            itemstack = (ItemStack)iterator1.next();
+        for (RecipeEntryFurnace r : Registries.RECIPES.getAllFurnaceRecipes()){
+            if (r.getOutput() != null){
+                craftable.add(r.getOutput().itemID);
+            }
         }
-
-        craftedItemStats = new Stat[Item.itemsList.length];
-        Iterator iterator2 = hashset.iterator();
-        do
-        {
-            if(!iterator2.hasNext())
-            {
-                break;
+        for (RecipeEntryBlastFurnace r : Registries.RECIPES.getAllBlastFurnaceRecipes()){
+            if (r.getOutput() != null){
+                craftable.add(r.getOutput().itemID);
             }
-            Integer integer = (Integer)iterator2.next();
-            if(Item.itemsList[integer.intValue()] != null)
-            {
-                craftedItemStats[integer.intValue()] = (new StatItem(0x1010000 + integer.intValue(), "stat.craftItem", integer.intValue())).registerStat();
+        }
+        for (RecipeEntryTrommel r : Registries.RECIPES.getAllTrommelRecipes()){
+            if (r.getOutput() != null) {
+                WeightedRandomBag<WeightedRandomLootObject> bag = r.getOutput();
+                for (WeightedRandomLootObject o : bag.getEntries()){
+                    ItemStack stack = o.getItemStack();
+                    if (stack != null){
+                        craftable.add(stack.itemID);
+                    }
+                }
             }
-        } while(true);
-
-        pickUpItemStats = new Stat[Item.itemsList.length];
-        for (int i = 0; i < Item.itemsList.length; i++)
-        {
-            pickUpItemStats[i] = (new StatItem(0x1040000 + i, "", i)).registerStat().setClientside();
+        }
+        for (Integer i : craftable){
+            Item.itemsList[i].createStat(STAT_CRAFTED, "stat.craftItem");;
         }
 
         mobEncounterStats = new HashMap<>();
         for (Map.Entry<String, Class<? extends Entity>> entry : EntityDispatcher.keyToClassMap.entrySet())
         {
-            mobEncounterStats.put(entry.getKey(), new StatMob(0x1050000 + EntityDispatcher.getEntityID(entry.getValue()), "stat.encounterMob", entry.getKey()).registerStat());
+            mobEncounterStats.put(entry.getKey(), new StatMob(new NamespaceID("minecraft", "encounter_" + entry.getKey()), "stat.encounterMob", entry.getKey()).registerStat());
         }
+    }
 
-        replaceAllSimilarBlocks(craftedItemStats);
+    @Nullable
+    public static Stat getStat(NamespaceID id) {
+        return statMap.get(id);
     }
 
-    private static Stat[] func_25153_a(String s, int i)
-    {
-        Stat astatbase[] = new Stat[Block.blocksList.length];
-        for (int j = 0; j < Block.blocksList.length; j++)
-        {
-            if(Block.blocksList[j] != null && Block.blocksList[j].getEnableStats())
-            {
-                astatbase[j] = (new StatItem(i + j, s, j)).registerStat();
-                statList3.add((StatItem)astatbase[j]);
+    @Unmodifiable
+    public static Collection<Stat> getAllStats(){
+        return Collections.unmodifiableCollection(statMap.values());
+    }
+
+    public static class StatConverter {
+        public static final int OFFSET_OFFSET =      0x001_0000;
+        public static final int OFFSET_MINED =       0x100_0000;
+        public static final int OFFSET_CRAFTED =     0x101_0000;
+        public static final int OFFSET_USED =        0x102_0000;
+        public static final int OFFSET_DEPLETED =    0x103_0000;
+        public static final int OFFSET_PICKED_UP =   0x104_0000;
+        public static final int OFFSET_MOB =         0x105_0000;
+        public static final int OFFSET_ACHIEVEMENT = 0x050_0000;
+
+        /**
+         * @param id Stat ID from BTA version before 7.3
+         * @return Equivalent current Stat object or null if no corresponding stat could be found
+         */
+        public static @Nullable Stat getStatFromDeprecatedID(int id) {
+            switch (id) {
+                case 1000:
+                    return startGameStat;
+                case 1001:
+                    return createWorldStat;
+                case 1002:
+                    return loadWorldStat;
+                case 1003:
+                    return joinMultiplayerStat;
+                case 1004:
+                    return leaveGameStat;
+                case 1100:
+                    return minutesPlayedStat;
+                case 2000:
+                    return distanceWalkedStat;
+                case 2001:
+                    return distanceSwumStat;
+                case 2002:
+                    return distanceFallenStat;
+                case 2003:
+                    return distanceClimbedStat;
+                case 2004:
+                    return distanceFlownStat;
+                case 2005:
+                    return distanceDoveStat;
+                case 2006:
+                    return distanceByMinecartStat;
+                case 2007:
+                    return distanceByBoatStat;
+                case 2008:
+                    return distanceByPigStat;
+                case 2010:
+                    return jumpStat;
+                case 2011:
+                    return dropStat;
+                case 2020:
+                    return damageDealtStat;
+                case 2021:
+                    return damageTakenStat;
+                case 2022:
+                    return deathsStat;
+                case 2023:
+                    return mobKillsStat;
+                case 2024:
+                    return playerKillsStat;
+                case 2025:
+                    return fishCaughtStat;
             }
-        }
 
-        replaceAllSimilarBlocks(astatbase);
-        return astatbase;
-    }
+            if (OFFSET_MINED <= id && id < OFFSET_MINED + OFFSET_OFFSET) {
+                Item i = Item.getItem(id - OFFSET_MINED);
+                return i == null ? null : i.getStat(STAT_MINED);
+            }
 
-    private static Stat[] initUsedItemStats(Stat astatbase[], String s, int i, int j, int k)
-    {
-        if(astatbase == null)
-        {
-            astatbase = new Stat[Item.itemsList.length];
-        }
-        for (int l = j; l < k; l++)
-        {
-            if(Item.itemsList[l] == null)
-            {
-                continue;
+            if (OFFSET_CRAFTED <= id && id < OFFSET_CRAFTED + OFFSET_OFFSET) {
+                Item i = Item.getItem(id - OFFSET_CRAFTED);
+                return i == null ? null : i.getStat(STAT_CRAFTED);
             }
-            astatbase[l] = (new StatItem(i + l, s, l)).registerStat();
-            if(l >= Block.blocksList.length)
-            {
-                usedItemStatsList.add((StatItem)astatbase[l]);
+
+            if (OFFSET_USED <= id && id < OFFSET_USED + OFFSET_OFFSET) {
+                Item i = Item.getItem(id - OFFSET_USED);
+                return i == null ? null : i.getStat(STAT_USED);
             }
-        }
 
-        replaceAllSimilarBlocks(astatbase);
-        return astatbase;
-    }
+            if (OFFSET_DEPLETED <= id && id < OFFSET_DEPLETED + OFFSET_OFFSET) {
+                Item i = Item.getItem(id - OFFSET_DEPLETED);
+                return i == null ? null : i.getStat(STAT_DEPLETED);
+            }
 
-    private static Stat[] initBreakItemStats(Stat astatbase[], String s, int i, int j, int k)
-    {
-        if(astatbase == null)
-        {
-            astatbase = new Stat[Item.itemsList.length];
-        }
-        for (int l = j; l < k; l++)
-        {
-            if(Item.itemsList[l] != null && Item.itemsList[l].isDamagable())
-            {
-                astatbase[l] = (new StatItem(i + l, s, l)).registerStat();
+            if (OFFSET_PICKED_UP <= id && id < OFFSET_PICKED_UP + OFFSET_OFFSET) {
+                Item i = Item.getItem(id - OFFSET_PICKED_UP);
+                return i == null ? null : i.getStat(STAT_PICKED_UP);
             }
-        }
 
-        replaceAllSimilarBlocks(astatbase);
-        return astatbase;
-    }
+            if (OFFSET_MOB <= id && id < OFFSET_MOB + OFFSET_OFFSET) {
+                Class<? extends Entity> c = EntityDispatcher.getClassFromID(id - OFFSET_MOB);
+                String entityID = EntityDispatcher.getEncodeId(c);
+                return mobEncounterStats.get(entityID);
+            }
 
-    private static void replaceAllSimilarBlocks(Stat astatbase[])
-    {
-        replaceSimilarBlocks(astatbase, Block.fluidWaterStill.id, Block.fluidWaterFlowing.id);
-        replaceSimilarBlocks(astatbase, Block.fluidLavaStill.id, Block.fluidLavaStill.id);
-        replaceSimilarBlocks(astatbase, Block.pumpkinCarvedActive.id, Block.pumpkinCarvedIdle.id);
-        replaceSimilarBlocks(astatbase, Block.furnaceStoneActive.id, Block.furnaceStoneIdle.id);
-        replaceSimilarBlocks(astatbase, Block.oreRedstoneGlowingStone.id, Block.oreRedstoneStone.id);
-        replaceSimilarBlocks(astatbase, Block.repeaterActive.id, Block.repeaterIdle.id);
-        replaceSimilarBlocks(astatbase, Block.torchRedstoneActive.id, Block.torchRedstoneIdle.id);
-        replaceSimilarBlocks(astatbase, Block.mushroomRed.id, Block.mushroomBrown.id);
-        replaceSimilarBlocks(astatbase, Block.grass.id, Block.dirt.id);
-        replaceSimilarBlocks(astatbase, Block.farmlandDirt.id, Block.dirt.id);
-    }
+            if (OFFSET_ACHIEVEMENT <= id && id < OFFSET_MINED) {
+                int achievementID = id - OFFSET_ACHIEVEMENT;
+                switch (achievementID) {
+                    case 0:
+                        return Achievements.OPEN_INVENTORY;
+                    case 1:
+                        return Achievements.MINE_WOOD;
+                    case 2:
+                        return Achievements.BUILD_WORKBENCH;
+                    case 3:
+                        return Achievements.BUILD_PICKAXE;
+                    case 4:
+                        return Achievements.BUILD_FURNACE;
+                    case 5:
+                        return Achievements.ACQUIRE_IRON;
+                    case 6:
+                        return Achievements.BUILD_HOE;
+                    case 7:
+                        return Achievements.MAKE_BREAD;
+                    case 8:
+                        return Achievements.BAKE_CAKE;
+                    case 9:
+                        return Achievements.BUILD_BETTER_PICKAXE;
+                    case 10:
+                        return Achievements.COOK_FISH;
+                    case 11:
+                        return Achievements.ON_A_RAIL;
+                    case 12:
+                        return Achievements.BUILD_SWORD;
+                    case 13:
+                        return Achievements.KILL_ENEMY;
+                    case 14:
+                        return Achievements.KILL_COW;
+                    case 15:
+                        return Achievements.FLY_PIG;
+                    case 16:
+                        return Achievements.GET_SENSED;
+                    case 17:
+                        return Achievements.CRAFT_HANDCANNON;
+                    case 18:
+                        return Achievements.COLLECT_STONE;
+                    case 19:
+                        return Achievements.CRUSH_BLOCKS;
+                    case 20:
+                        return Achievements.REPAIR_ARMOR;
+                    case 21:
+                        return Achievements.GET_CHAINMAIL;
+                    case 22:
+                        return Achievements.OPEN_GUIDEBOOK;
+                    case 23:
+                        return Achievements.CAUGHT_EM_ALL;
+                }
+            }
 
-    private static void replaceSimilarBlocks(Stat astatbase[], int i, int j)
-    {
-        if(astatbase[i] != null && astatbase[j] == null)
-        {
-            astatbase[j] = astatbase[i];
-            return;
-        } else
-        {
-            statList1.remove(astatbase[i]);
-            statList3.remove(astatbase[i]);
-            statList2.remove(astatbase[i]);
-            astatbase[i] = astatbase[j];
-            return;
+            return null;
         }
     }
-
-    public static Stat getStat(int i)
-    {
-        return statMap.get(i);
-    }
 }
diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatMob.java b/src/main/java/net/minecraft/core/achievement/stat/StatMob.java
index 567bcd8e1..b7624def4 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/StatMob.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatMob.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.achievement.stat;
 
+import net.minecraft.core.util.collection.NamespaceID;
+
 public class StatMob extends Stat {
     private final String mobId;
 
-    public StatMob(int id, String name, String mobId) {
+    public StatMob(NamespaceID id, String name, String mobId) {
         super(id, name);
         this.mobId = mobId;
     }
diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatValueFormatter.java b/src/main/java/net/minecraft/core/achievement/stat/StatValueFormatter.java
new file mode 100644
index 000000000..f1263ab9d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatValueFormatter.java
@@ -0,0 +1,6 @@
+package net.minecraft.core.achievement.stat;
+
+
+public interface StatValueFormatter {
+    String formatValue(int value);
+}
